<?php

namespace Boomee\Service;

use User;

class Service
{
    /**
     * $deal object.
     */
    protected $deal;    /**
     * $service object.
     */
    protected $service;

    /**
     * Constructor.
     */
    public function __construct(\Boomee\Service\Interfaces\DealRepositoryInterface $deal,        \Boomee\Service\Interfaces\ServiceRepositoryInterface $service)
    {
        $this->deal = $deal;        $this->service = $service;
    }

    /**
     * Returns count of service.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.deal.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->deal->pushCriteria(new \Litepie\Boomee\Repositories\Criteria\DealUserCriteria());
        }

        $deal = $this->deal->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('service::' . $view, compact('deal'))->render();
    }    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.service.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->service->pushCriteria(new \Litepie\Boomee\Repositories\Criteria\ServiceUserCriteria());
        }

        $service = $this->service->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('service::' . $view, compact('service'))->render();
    }
}
